	list p=16F628
	include "p16f628.inc"
	ERRORLEVEL	-302
	__CONFIG _BODEN_OFF&_CP_OFF&_PWRTE_ON&_WDT_OFF&_LVP_OFF&_MCLRE_ON&_XT_OSC

;DEFINICION DE MACROS
BANK0	macro
	bcf	STATUS,RP0
	bcf	STATUS,RP1
	endm
BANK1	macro
	bsf	STATUS,RP0
 	bcf	STATUS,RP1
	endm
BANK2	macro
	bcf	STATUS,RP0
	bsf	STATUS,RP1
	endm
BANK3	macro
	bsf	STATUS,RP0
	bsf	STATUS,RP1
	endm


		CBLOCK	0X20
			DECENA,UNIDAD,AUX,PRUE
			TEMP1,TEMP2,CAR,REGA,REGB,REG_A
			COD1,COD2,COD3,COD4,COD5,COD6,COD7,COD8
			REG,TEMP,MEMO,NUMERO,CONTA
			DIGI1,DIGI2,DIGI3,DIGI4,DIGI5
			INIF
			G_W,G_S	
		ENDC
		
		
		ORG	00				;origen Vector de reset
		GOTO	CONFIG
		ORG	04				;origen del vector de interrupcion
		GOTO	INTER

TABLA	MOVWF	PCL

M_INI1	EQU	$
	DT          "HOVEL",0

M_INI2	EQU	$
	DT          "ELECTRONICA",0
		
M_CHI       EQU         $
            DT          "CHICHIMENE",0
            
M_CA1       EQU         $
            DT          "CASTILLA 1",0

M_CA2       EQU         $
            DT          "CASTILLA 2",0

M_EMER      EQU         $
            DT          "EMERGENCIA",0

M_TEST      EQU         $
            DT          "PRUEBA-TEST",0

M_AUXI      EQU         $
            DT          "AUXILIAR",0
           
                                                  

T_ANIS                  MOVF        CONTA,W
                 	ADDWF	PCL,F
	

;Mensaje: Esta rutina envia dato por USART cuyo inicio est indicado en
 ;el acumulador

MENSAJE		movwf	TEMP1          ;Salva posicin de la tabla
		movf	TEMP1,w        ;Recupera posicin de la tabla
		call	TABLA           ;Busca caracter de salida
		movwf	TEMP2          ;Guarda el caracter
		movf	TEMP2,f
		btfsc	STATUS,Z        ;Mira si es el ltimo
		return
		call	DATOLCD       	;envia dato via rs232
		incf	TEMP1,f        ;Siguiente caracter
		goto	$-8				;Repite con siguiente caracter

;****************************************************************
;* RUTINAS DE MANEJO DE UN LCD ALFANUMERICO 2x16 A 4 BITS	*
;****************************************************************
;Pulso de Enable
;habilita el LCD para que tome el valor que hay en el puerto y lo procese

PULS_E          bsf     PORTB,3         ;Activa seal E
                nop                     ;Espera 1 uS
                bcf     PORTB,3         ;Desactiva seal E
                return
;-------------------------------------------------------------------------
; Escritura de datos en DDRAM o CGRAM
; el dato esta en el acumulador

DATOLCD		bsf	PORTB,2		;activa RS (modo DATO)
		MOVWF	CAR
		movf        PORTB,W
		ANDLW       0X0F
		MOVWF       REGA
		MOVF        CAR,W
	           	ANDLW	0XF0
	            IORWF       REGA,w
		movwf       PORTB		;enva nible alto del dato
		CALL	PULS_E
		SWAPF	CAR,W
		ANDLW	0XF0
		IORWF       REGA,W
		MOVWF	PORTB		;enva nible bajo del dato
		CALL        PULS_E		;Genera pulso en la seal E
		CALL	RETA5MS
		RETURN
;------------------------------------------------------------------------
; Escritura de comandos en el LCD
; el comando esta en el acumulador

REGLCD      	bcf         PORTB,2		;Desactiva RS (modo comando)
		MOVWF	CAR
		movf        PORTB,W
		ANDLW       0X0F
		MOVWF       REGA
		MOVF        CAR,W
	           	ANDLW	0XF0
	            IORWF       REGA,w
		movwf       PORTB		;enva nible alto del dato
		CALL	PULS_E
		SWAPF	CAR,W
		ANDLW	0XF0
		IORWF       REGA,W
		MOVWF	PORTB		;enva nible bajo del dato
		CALL        PULS_E		;Genera pulso en la seal E
		CALL	RETA5MS
		RETURN
;------------------------------------------------------------------------
; Inicializacin del LCD  a 4 bits                    

LCD_INI	            MOVLW       0X3F
                        ANDWF       PORTB,F
                        MOVLW	0X30
		IORWF       PORTB,f
		CALL	PULS_E
		CALL	RETA5MS
		CALL	PULS_E
		CALL	RETA5MS
		CALL	PULS_E
		MOVLW       0X0F
                        ANDWF       PORTB,F
		MOVLW	0X20
		IORWF	PORTB
            	CALL	PULS_E
		CALL	RETA5MS
		MOVLW	0X28
		CALL	REGLCD
		MOVLW	0X08
		CALL	REGLCD
		RETURN

;-----------------------------------------------------------------
;Configura el PIC para el LCD.
UP_LCD      	bsf         STATUS,5        ;Banco 1
		MOVLW       0X01
		MOVWF	TRISB           ;Puerta B salida NIBLE low
		bcf         STATUS,5        ;Banco 0
		bcf         PORTB,2
		bcf         PORTB,3         ;E=0 Desactiva LCD
		return
;--------------------------------------------------------------------
INN		call        UP_LCD	
		call        LCD_INI        ;Inicia el mdulo LCD

INA         	movlw       b'00001100'
		call        REGLCD         ;LCD On y Cursor Off

		movlw   b'00000001'
		call    REGLCD         ;Borra display
		
		movlw       b'10000000'
		call	REGLCD
		return

; RUTINA AUXILIAR DE RETARDO
COTM		bsf 	STATUS,5 	; Seleccin del banco 1
		movlw	b'00000111'
		movwf	OPTION_REG		; Se asigna el preescaler al TMR0
		bcf 	STATUS,5 	; Seleccin del banco 0
  		return
RETA		bcf	 INTCON,2	; Borra el flag de estado del TMR0
		movlw	 0xD9
		movwf	 TMR0		; Carga del TMR0 para que cuente 39
		btfss	 INTCON,2	; Espera el desbordamiento del TMR0
		goto	 $-1
		decfsz	 REG_A,f	
		goto	 $-6
		return
 
 
; RUTINA DE RETARDO DE 1 SEGUNDO
 
 
RETA1S		call	COTM
		movlw	0x64
		movwf	REG_A	; Carga la variable TEMPO1, que ser decrementada 
		call	RETA	; en la rutina a la que se llama	
		return		
		
RETA5MS	
            	MOVLW	7
		MOVWF	REG_A
		MOVLW	.237
		MOVWF	REGB
		DECFSZ	REGB,F
		GOTO	$-1
		DECFSZ	REG_A,F
		GOTO	$-5
		RETURN		
CONFIG
		CLRF	PORTA
		CLRF        PORTB
		MOVLW	0X07		;inhabilito comparadores y habilto....
		MOVWF	CMCON		;...puerto A como E/S digitales

            	BANK1
		MOVLW	0X0F		;nible bajo del puerto A para...
		MOVWF	TRISA		;..BCD  del 8870 (q1..q4)
		MOVLW	0x01		;RB0 entrada para interrupcion externa (Std 8870)
		MOVWF	TRISB		;RB1 entrada, RB2 como salida (Rx, Tx  USART)
		BSF         OPTION_REG,6            ;HAB INT CON F ASCENDENTE
		movlw	B'10010000'	;habilito interrupcion externa y...
		MOVWF	INTCON		;todas las interrupciones
		BANK0
                        CLRF        INIF
                        bcf         PORTB,1
                        CALL        INN         ;INICIA LCD Y UBICA CURSOR L1,C1
                        MOVLW       0X85
                        CALL        REGLCD      ;ENVIA COMANDO A LC (POS PANTALLA)
                        MOVLW       M_INI1
                        CALL        MENSAJE

                        MOVLW       0XC2
                        CALL        REGLCD      ;ENVIA COMANDO A LC (POS PANTALLA)
                        MOVLW       M_INI2
                        CALL        MENSAJE

		GOTO	MAINPROG


;************************************************************************		
;rutina de tratamiento de la interrupcion de recpcion del USART
INTER       	movwf	G_W			;guardo el acumulador
		SWAPF	STATUS,W	
		BANK0
		MOVWF	G_S			;guardo	registro STATUS
		BTFSC       INTCON,T0I
		GOTO        TEMPO
		bcf	INTCON,INTF	;limpio bandera de interrupcion EXTERNA
                        MOVF        PORTA,W
                        ANDLW       0X0F
                        MOVWF       TEMP
                                    
                        MOVLW       0x0B
                        XORWF       TEMP,W
                        BTFSS       STATUS,Z
                        GOTO        CONFIR
                        CLRF        INIF
                        BSF         INIF,0
                        GOTO        SALIR

CONFIR                  
                        BTFSS       INIF,0
                        GOTO        SALIR
                        BTFSC       INIF,1
                        GOTO        G_DIG2
                        BSF         INIF,1
                        MOVF        TEMP,W
                        MOVWF       DIGI1
                        GOTO        SALIR       

G_DIG2                  BTFSC       INIF,2
                        GOTO        G_DIG3
                        BSF         INIF,2
                        MOVF        TEMP,W
                        MOVWF       DIGI2
                        GOTO        SALIR       

G_DIG3                  BTFSC       INIF,3
                        GOTO        G_DIG4
                        BSF         INIF,3
                        MOVF        TEMP,W
                        MOVWF       DIGI3
                        GOTO        SALIR
                               
G_DIG4                  BTFSC       INIF,4
                        GOTO        G_DIG5
                        BSF         INIF,4
                        MOVF        TEMP,W
                        MOVWF       DIGI4
                        GOTO        SALIR
                        
G_DIG5                  BTFSC       INIF,5
                        GOTO        D_FINAL
                        BSF         INIF,5
                        MOVF        TEMP,W
                        MOVWF       DIGI5
                        GOTO        SALIR       
                              
D_FINAL                 BTFSC       INIF,6
                        GOTO        SALIR
                        CLRF        INIF
                        MOVLW       0X0C
                        XORWF       TEMP,W
                        BTFSS       STATUS,Z
                        GOTO        SALIR
                        BSF         INIF,6
                        GOTO        SALIR       

TEMPO                   ;TEMPORIZACION ?
		
SALIR		SWAPF	G_S,W		;se recuper registro STATUS
		MOVWF	STATUS
		SWAPF	G_W,F	
		SWAPF	G_W,W		;se recupera el caumulador
	  	retfie			;sale de la interrupcin
		
		
MAINPROG	         
                        BCF         PORTA,4
                        CALL        RETA1S
                        BSF         PORTA,4
                        CALL        RETA1S
                        BTFSS       INIF,6
                        GOTO        $-5
                        clrf        INIF
                        CLRF        NUMERO
            	MOVLW	.10		;valor de cantdidad de claves
		MOVWF	REG		;reg. determina a que correponde la clave
		MOVLW	.128		;valor de ultimo byte de eeprom
		MOVWF	MEMO
		CALL	COMPARA		;rutina que verifica claves
		BTFSS	NUMERO,0	;la clave existe?
		GOTO	MAINPROG	;no...
                       
         	            
                            
CA2_AUXI                MOVLW       .9
                        XORWF        REG,W
                        BTFSS       STATUS,Z
                        GOTO        CA2_TEST
                        CALL        INA
                        MOVLW       0X83
                        CALL        REGLCD      ;POSICIONA CURSOR DE LCD (L1,C4)
                        
                        MOVLW       M_CA2
                        CALL        MENSAJE
                        
                        MOVLW       0xc3
                        CALL        REGLCD
                        MOVLW       M_AUXI
                        CALL        MENSAJE
                        GOTO        MAINPROG      
                                 
CA2_TEST                MOVLW       .8
                        XORWF       REG,W
                        BTFSS       STATUS,Z
                        GOTO        CA2_EMER
                        CALL        INA
                        MOVLW       0X83
                        CALL        REGLCD      ;POSICIONA CURSOR DE LCD (L1,C4)
                        
                        MOVLW       M_CA2
                        CALL        MENSAJE
                        
                        MOVLW       0xc3
                        CALL        REGLCD
                        MOVLW       M_TEST
                        CALL        MENSAJE
                        GOTO        MAINPROG      
                       
CA2_EMER                MOVLW       .7
                        XORWF       REG,W
                        BTFSS       STATUS,Z
                        GOTO        CA1_AUXI
                        CALL        INA
                        MOVLW       0X83
                        CALL        REGLCD      ;POSICIONA CURSOR DE LCD (L1,C4)
                        
                        MOVLW       M_CA2
                        CALL        MENSAJE
                        
                        MOVLW       0xc3
                        CALL        REGLCD
                        MOVLW       M_EMER
                        CALL        MENSAJE
                        BSF         PORTB,1
                        GOTO        MAINPROG      


CA1_AUXI                MOVLW       .6
                        XORWF        REG,W
                        BTFSS       STATUS,Z
                        GOTO        CA1_TEST
                        CALL        INA
                        MOVLW       0X83
                        CALL        REGLCD      ;POSICIONA CURSOR DE LCD (L1,C4)
                        
                        MOVLW       M_CA1
                        CALL        MENSAJE
                        
                        MOVLW       0xc3
                        CALL        REGLCD
                        MOVLW       M_AUXI
                        CALL        MENSAJE
                        GOTO        MAINPROG      
                                 
CA1_TEST                MOVLW       .5
                        XORWF       REG,W
                        BTFSS       STATUS,Z
                        GOTO        CA1_EMER
                        CALL        INA
                        MOVLW       0X83
                        CALL        REGLCD      ;POSICIONA CURSOR DE LCD (L1,C4)
                        
                        MOVLW       M_CA1
                        CALL        MENSAJE
                        
                        MOVLW       0xc3
                        CALL        REGLCD
                        MOVLW       M_TEST
                        CALL        MENSAJE
                        GOTO        MAINPROG      
                       
CA1_EMER                MOVLW       .4
                        XORWF       REG,W
                        BTFSS       STATUS,Z
                        GOTO        CHI_AUXI
                        CALL        INA
                        MOVLW       0X83
                        CALL        REGLCD      ;POSICIONA CURSOR DE LCD (L1,C4)
                        
                        MOVLW       M_CA1
                        CALL        MENSAJE
                        
                        MOVLW       0xc3
                        CALL        REGLCD
                        MOVLW       M_EMER
                        CALL        MENSAJE
                        BSF         PORTB,1
                        GOTO        MAINPROG
                              
CHI_AUXI                MOVLW       .3
                        XORWF       REG,W
                        BTFSS       STATUS,Z
                        GOTO        CHI_TEST
                        CALL        INA
                        MOVLW       0X83
                        CALL        REGLCD      ;POSICIONA CURSOR DE LCD (L1,C4)
                        
                        MOVLW       M_CHI
                        CALL        MENSAJE
                        
                        MOVLW       0xc3
                        CALL        REGLCD
                        MOVLW       M_AUXI
                        CALL        MENSAJE
                        GOTO        MAINPROG      
                                 
CHI_TEST                MOVLW       .2
                        XORWF       REG,W
                        BTFSS       STATUS,Z
                        GOTO        CHI_EMER
                        CALL        INA
                        MOVLW       0X83
                        CALL        REGLCD      ;POSICIONA CURSOR DE LCD (L1,C4)
                        
                        MOVLW       M_CHI
                        CALL        MENSAJE
                        
                        MOVLW       0xc3
                        CALL        REGLCD
                        MOVLW       M_TEST
                        CALL        MENSAJE
                        GOTO        MAINPROG      
                       
CHI_EMER                MOVLW       .1
                        XORWF       REG,W
                        BTFSS       STATUS,Z
                        GOTO        MAINPROG
                        CALL        INA
                        MOVLW       0X83
                        CALL        REGLCD      ;POSICIONA CURSOR DE LCD (L1,C4)
                        
                        MOVLW       M_CHI
                        CALL        MENSAJE
                        
                        MOVLW       0xc3
                        CALL        REGLCD
                        MOVLW       M_EMER
                        CALL        MENSAJE
                        BSF         PORTB,1
                        GOTO        MAINPROG      

COMPARA	            DECFSZ	REG,F		;
		GOTO	$+2
		RETURN
		DECFSZ	MEMO,F
		GOTO	$+3
		BCF	NUMERO,0
		RETURN
		CALL	LEE628
		XORWF	DIGI1,W
		BTFSC	STATUS,Z
		GOTO	$+4
		MOVLW	.4
		SUBWF	MEMO,F
		GOTO	COMPARA

		DECFSZ	MEMO,F
		GOTO	$+3
		BCF	NUMERO,0
		RETURN
		CALL	LEE628
		XORWF	DIGI2,W
		BTFSC	STATUS,Z
		GOTO	$+4
		MOVLW	.3
		SUBWF	MEMO,F
		GOTO	COMPARA
		
		DECFSZ	MEMO,F
		GOTO	$+3
		BCF	NUMERO,0
		RETURN
		CALL	LEE628
		XORWF	DIGI3,W
		BTFSC	STATUS,Z
		GOTO	$+4
		MOVLW	.2
		SUBWF	MEMO,F
		GOTO	COMPARA
		
		DECFSZ	MEMO,F
		GOTO	$+3
		BCF	NUMERO,0
		RETURN
		CALL	LEE628
		XORWF	DIGI4,W
		BTFSC	STATUS,Z
		GOTO	$+4
		MOVLW	.1
		SUBWF	MEMO,F
		GOTO	COMPARA

		DECFSZ	MEMO,F
		GOTO	$+3
		BCF	NUMERO,0
		RETURN
		CALL	LEE628
		XORWF	DIGI5,W
		BTFSC	STATUS,Z
		GOTO	$+4
		MOVLW	.0
		SUBWF	MEMO,F
		GOTO	COMPARA
		BSF	NUMERO,0
		RETURN



LEE628		MOVF	MEMO,W		;direccion a leer0
		BANK1
		MOVWF	EEADR
		BSF	EECON1,RD
		NOP
		MOVF	EEDATA,W
		BANK0
		RETURN


;esta parte del programa escribe datos en la EEPROM al programarlo
; el vector de origen de la memoria es 2100 HEXADECIMAL y fin  es 2180 hexa

;2180H-45H= 2135H

		ORG	H'2153'		

            	DE                      .9,.9,.1,0X0A,0X0A              ;reporte emergencia		
		DE                      .8,.9,.1,0X0A,0X0A	    ;reporta test       	
		DE                      .7,.9,.1,0X0A,0X0A	

            	DE                      .9,.9,.2,0X0A,0X0A              ;reporte emergencia		
		DE                      .8,.9,.2,0X0A,0X0A	    ;reporta test       	
		DE                      .7,.9,.2,0X0A,0X0A

            	DE                      .9,.9,.3,0X0A,0X0A              ;reporte emergencia		
		DE                      .8,.9,.3,0X0A,0X0A	    ;reporta test       	
		DE                      .7,.9,.3,0X0A,0X0A
                        
		END


