;SE TRABAJA EL LCD A 4 BITS
	list p=16F84A
	include "p16f84A.inc"

	__CONFIG _CP_OFF&_PWRTE_ON&_WDT_OFF&_XT_OSC
	ERRORLEVEL	-302
;DEFINICION DE MACROS
BANK0	macro
	bcf	STATUS,RP0
	bcf	STATUS,RP1
	endm
BANK1	macro
	bsf	STATUS,RP0
 	bcf	STATUS,RP1
	endm
BANK2	macro
	bcf	STATUS,RP0
	bsf	STATUS,RP1
	endm
BANK3	macro
	bsf	STATUS,RP0
	bsf	STATUS,RP1
	endm	

              cblock  0x20
			TEST,TEMPO
			UNIDAD,DECENA,CENTENA,AUX,CENT
			DATO,DATOS,UNI,DEC,NUM,DATO_A,DATO_B
			REGA,REGB,CAR,DATOL,DATOH		
			TEMPP,DATEMP,TEMP,SEGUNDO		
			CONTA,ADDRI2C,D_I2C,CONTAI
			CONT
			
			temp_1,temp_2
			G_W,G_S
                endc


		org	00
		
		org	05
		GOTO	CONFIG
		

TABLALCD

		MOVWF	PCL
MENS_1	EQU		$
		DT		'L',' ','C',' ','D',' ','s',0
		
MENS_2	EQU	$
		DT		'L',' ','A',' ',' ','R',' ','E',' ','D',0
MENSAJELCD	movwf   temp_1          ;Salva posicin de la tabla
		movf    temp_1,w        ;Recupera posicin de la tabla
                call    TABLALCD           ;Busca caracter de salida
                movwf   temp_2          ;Guarda el caracter
                movf    temp_2,f
                btfsc   STATUS,Z        ;Mira si es el ltimo
                return
		call    DATOLCD        	;Visualiza en el LCD
                incf    temp_1,f        ;Siguiente caracter
                goto    $-8	        ;Repite con siguiente caracter		

RETA5MS		MOVLW	.7
		MOVWF	REGA
		MOVLW	.237
		MOVWF	REGB
		DECFSZ	REGB,F
		GOTO	$-1
		DECFSZ	REGA,F
		GOTO	$-5
		RETURN



;****************************************************************
;* RUTINAS DE MANEJO DE UN LCD ALFANUMERICO 2x16 A 4 BITS	*
;****************************************************************
;Pulso de Enable
;habilita el LCD para que tome el valor que hay en el puerto y lo procese

PULS_E          bsf     PORTA,1         ;Activa seal E
                nop                     ;Espera 1 uS
                bcf     PORTA,1         ;Desactiva seal E
                return
;-------------------------------------------------------------------------
; Escritura de datos en DDRAM o CGRAM
; el dato esta en el acumulador

DATOLCD		bsf	PORTA,0		;activa RS (modo DATO)
		MOVWF	CAR
		SWAPF	CAR,W
		ANDLW	0X0F
		movwf   PORTB		;enva nible alto del dato
		CALL	PULS_E
		MOVF	CAR,W
		ANDLW	0X0F
		MOVWF	PORTB		;enva nible bajo del dato
		CALL    PULS_E		;Genera pulso en la seal E
		CALL	RETA5MS
		RETURN
;------------------------------------------------------------------------
; Escritura de comandos en el LCD
; el comando esta en el acumulador

REGLCD	        bcf     PORTA,0		;Desactiva RS (modo comando)
		MOVWF	CAR
		SWAPF	CAR,W
		ANDLW	0X0F	
                movwf   PORTB		;enva la parte alta del comando
		CALL	PULS_E
		MOVF	CAR,W
		ANDLW	0X0F
		MOVWF	PORTB		;enva nible bajo del comando
                CALL    PULS_E		;Genera pulso en la seal E
		CALL	RETA5MS
		RETURN
;------------------------------------------------------------------------
; Inicializacin del LCD  a 4 bits                    

LCD_INI		MOVLW	03
		MOVWF	PORTB
		CALL	PULS_E
		CALL	RETA5MS
		CALL	PULS_E
		CALL	RETA5MS
		CALL	PULS_E
		MOVLW	02
		MOVWF	PORTB
		CALL	PULS_E
		CALL	RETA5MS
		MOVLW	0X28
		CALL	REGLCD
		MOVLW	0X08
		CALL	REGLCD
		RETURN

;-----------------------------------------------------------------
;Configura el PIC para el LCD.
UP_LCD          bsf     STATUS,5        ;Banco 1
		MOVLW	0XF0
		MOVWF	TRISB           ;Puerta B salida NIBLE low
                clrf	TRISA           ;Puerta A salida
                bcf     STATUS,5        ;Banco 0
                clrf    INTCON          ;Desactivar interrupciones.
                bcf     PORTA,0         ;RS=0
 		bcf     PORTA,1         ;E=0 Desactiva LCD
 		return
;--------------------------------------------------------------------
INN		call	UP_LCD	
                call    LCD_INI        ;Inicia el mdulo LCD

INNA		movlw   b'00001100'
                call    REGLCD         ;LCD On y Cursor Off

                movlw   b'00000001'
                call    REGLCD         ;Borra display
		
		movlw	b'10000000'
		call	REGLCD
		return
;------------------------------------------------------------------------

; RUTINA AUXILIAR DE RETARDO
COTM		bsf 	STATUS,5 	; Seleccin del banco 1
		movlw	b'00000111'
		movwf	TMR0		; Se asigna el preescaler al TMR0
		bcf 	STATUS,5 	; Seleccin del banco 0
  		return
RETA		bcf	 INTCON,2	; Borra el flag de estado del TMR0
		movlw	 0xD9
		movwf	 TMR0		; Carga del TMR0 para que cuente 39
		btfss	 INTCON,2	; Espera el desbordamiento del TMR0
		goto	 $-1
		decfsz	 REGA,f	
		goto	 $-6
		return
 
 
; RUTINA DE RETARDO DE 1 SEGUNDO
 
 
RETA1S		call	COTM
		movlw	0x64
		movwf	REGA	; Carga la variable TEMPO1, que ser decrementada 
		call	RETA	; en la rutina a la que se llama	
		return

RETA100MS
		MOVLW	.197
		MOVWF	REGB
		MOVLW	.221
		MOVWF	REGA
		DECFSZ	REGA,F
		GOTO	$-1
		DECFSZ	REGB,F
		GOTO	$-3
		RETURN
;------------------------------------------------------------------------




CONFIG
;	MOVLW	.7
;	MOVWF	CMCON
	call	RETA100MS
	BSF	STATUS,RP0
	MOVLW	0XF0
	MOVWF	TRISB
	CLRF	PORTA
	BCF	STATUS,RP0
	CALL	INN
	MOVLW	.17
	MOVWF	CONTA	
PRINCIPAL
		CLRF	TEST
		CALL	INNA
		MOVLW	.31
		MOVWF	DATOH
SEG_A	INCFSZ	DATOH,F
		GOTO	V_ASCII
		CALL	INNA
		MOVLW	0X84
		CALL	REGLCD
		MOVLW	MENS_1
		CALL	MENSAJELCD
		CALL	RETA1S
		MOVLW	0XC3
		CALL	REGLCD
		MOVLW	MENS_2
		CALL	MENSAJELCD
		CALL	RETA1S
		goto	PRINCIPAL

V_ASCII	DECFSZ	CONTA,F
		GOTO	VER
		MOVLW	.16
		MOVWF	CONTA
		BTFSS	TEST,0
		GOTO	$+5
		BCF		TEST,0
		CALL	RETA1S
		MOVLW	0X80
		GOTO	$+3
		MOVLW	0XC0
		BSF		TEST,0
		CALL	REGLCD
VER		MOVLW	.129
		XORWF	DATOH,W
		BTFSS	STATUS,Z
		GOTO	$+3
		MOVLW	.161
		MOVWF	DATOH
		MOVF	DATOH,W
		CALL	DATOLCD
		CALL	RETA100MS
		GOTO	SEG_A	
         END


